2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
6 # SPDX-License-Identifier: GPL-2.0+
10 # if exiting with 0, write to stdout, else write to stderr
12 [ "${ret}" -eq 1 ] && exec 1>&2
14 Usage: MAKEALL [options] [--] [boards-to-build]
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -b BOARD, --board BOARD Build all boards with board name BOARD
22 -l, --list List all targets to be built
23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
25 -C, --check Enable build checking
26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
28 -h, --help This help output
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
36 If no boards are specified, then the default is "powerpc".
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
46 BUILD_NBUILDS number of parallel targets (default: 1)
49 - build all Power Architecture boards:
51 MAKEALL --arch powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
66 # Option processing based on util-linux-2.13/getopt-parse.bash
68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
75 [ $? != 0 ] && usage 1
77 # Note the quotes around `$TEMP': they are essential!
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
94 opt_a="(\$2 == \"$2\")"
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
121 opt_v="(\$5 == \"$2\")"
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
162 echo "Internal error!" >&2 ; exit 1 ;;
166 GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
171 # echo "Remaining arguments:"
172 # for arg do echo '--> '"\`$arg'" ; done
174 tools/genboardscfg.py || {
175 echo "Failed to generate boards.cfg" >&2
180 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
181 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
182 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
183 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
184 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
186 if [ "$SELECTED" ] ; then
187 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
189 # Make sure some boards from boards.cfg are actually found
190 if [ -z "$SELECTED" ] ; then
191 echo "Error: No boards selected, invalid arguments"
196 #########################################################################
198 # Print statistics when we exit
202 # Determine number of CPU cores if no default was set
203 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
205 if [ "$BUILD_NCPUS" -gt 1 ]
207 JOBS="-j $((BUILD_NCPUS + 1))"
212 if [ "${MAKEALL_LOGDIR}" ] ; then
213 LOG_DIR=${MAKEALL_LOGDIR}
218 : ${BUILD_NBUILDS:=1}
221 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
223 : ${BUILD_DIR:=./build}
224 mkdir -p "${BUILD_DIR}/ERR"
225 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
230 OUTPUT_PREFIX="${BUILD_DIR}"
232 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
233 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
234 find "${LOG_DIR}/" -type f -exec rm -f {} +
239 # Keep track of the number of builds and errors
250 # Helper funcs for parsing boards.cfg
256 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
260 targets_by_arch() { targets_by_field 2 "$@" ; }
261 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
262 targets_by_soc() { targets_by_field 4 "$@" ; }
264 #########################################################################
266 #########################################################################
268 LIST_5xx="$(targets_by_cpu mpc5xx)"
270 #########################################################################
272 #########################################################################
274 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
276 #########################################################################
278 #########################################################################
280 LIST_512x="$(targets_by_cpu mpc512x)"
282 #########################################################################
284 #########################################################################
286 LIST_8xx="$(targets_by_cpu mpc8xx)"
288 #########################################################################
290 #########################################################################
292 LIST_4xx="$(targets_by_cpu ppc4xx)"
294 #########################################################################
296 #########################################################################
298 LIST_824x="$(targets_by_cpu mpc824x)"
300 #########################################################################
301 ## MPC8260 Systems (includes 8250, 8255 etc.)
302 #########################################################################
304 LIST_8260="$(targets_by_cpu mpc8260)"
306 #########################################################################
307 ## MPC83xx Systems (includes 8349, etc.)
308 #########################################################################
310 LIST_83xx="$(targets_by_cpu mpc83xx)"
312 #########################################################################
313 ## MPC85xx Systems (includes 8540, 8560 etc.)
314 #########################################################################
316 LIST_85xx="$(targets_by_cpu mpc85xx)"
318 #########################################################################
320 #########################################################################
322 LIST_86xx="$(targets_by_cpu mpc86xx)"
324 #########################################################################
326 #########################################################################
328 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
330 #########################################################################
332 #########################################################################
354 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
355 # still using "ppc" instead of "powerpc"
360 #########################################################################
362 #########################################################################
364 LIST_SA="$(targets_by_cpu sa1100)"
366 #########################################################################
368 #########################################################################
370 LIST_ARM7="$(targets_by_cpu arm720t)"
372 #########################################################################
374 #########################################################################
376 LIST_ARM9="$(targets_by_cpu arm920t) \
377 $(targets_by_cpu arm926ejs) \
378 $(targets_by_cpu arm946es) \
381 #########################################################################
383 #########################################################################
384 LIST_ARM11="$(targets_by_cpu arm1136) \
385 $(targets_by_cpu arm1176) \
388 #########################################################################
390 #########################################################################
392 LIST_ARMV7="$(targets_by_cpu armv7)"
394 #########################################################################
396 #########################################################################
398 LIST_ARMV8="$(targets_by_cpu armv8)"
400 #########################################################################
402 #########################################################################
404 LIST_at91="$(targets_by_soc at91)"
406 #########################################################################
408 #########################################################################
410 LIST_pxa="$(targets_by_cpu pxa)"
412 #########################################################################
414 #########################################################################
416 LIST_spear="$(targets_by_soc spear)"
418 #########################################################################
420 #########################################################################
422 LIST_arm="$(targets_by_arch arm | \
423 for ARMV8_TARGET in $LIST_ARMV8; \
424 do sed "/$ARMV8_TARGET/d"; \
428 #########################################################################
429 ## MIPS Systems (default = big endian)
430 #########################################################################
432 LIST_mips="$(targets_by_arch mips)"
434 #########################################################################
436 #########################################################################
438 LIST_openrisc="$(targets_by_arch openrisc)"
440 #########################################################################
442 #########################################################################
444 LIST_x86="$(targets_by_arch x86)"
446 #########################################################################
448 #########################################################################
450 LIST_nios2="$(targets_by_arch nios2)"
452 #########################################################################
453 ## MicroBlaze Systems
454 #########################################################################
456 LIST_microblaze="$(targets_by_arch microblaze)"
458 #########################################################################
460 #########################################################################
462 LIST_m68k="$(targets_by_arch m68k)"
463 LIST_coldfire=${LIST_m68k}
465 #########################################################################
467 #########################################################################
469 LIST_avr32="$(targets_by_arch avr32)"
471 #########################################################################
473 #########################################################################
475 LIST_blackfin="$(targets_by_arch blackfin)"
477 #########################################################################
479 #########################################################################
481 LIST_sh2="$(targets_by_cpu sh2)"
482 LIST_sh3="$(targets_by_cpu sh3)"
483 LIST_sh4="$(targets_by_cpu sh4)"
485 LIST_sh="$(targets_by_arch sh)"
487 #########################################################################
489 #########################################################################
491 LIST_sparc="$(targets_by_arch sparc)"
493 #########################################################################
495 #########################################################################
497 LIST_nds32="$(targets_by_arch nds32)"
499 #########################################################################
501 #########################################################################
503 LIST_arc="$(targets_by_arch arc)"
505 #-----------------------------------------------------------------------
507 get_target_location() {
515 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
516 if [ -z "${line}" ] ; then echo "" ; return ; fi
520 CONFIG_NAME="${7%_defconfig}"
522 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
524 if [ $# -gt 5 ]; then
525 if [ "$6" = "-" ] ; then
532 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
533 [ $# -gt 6 ] && [ "$8" != "-" ] && {
540 # Assign board directory to BOARDIR variable
541 if [ "${vendor}" == "-" ] ; then
544 BOARDDIR=${vendor}/${board}
547 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
550 get_target_maintainers() {
551 local name=`echo $1 | cut -d : -f 3`
553 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
554 if [ -z "${line}" ]; then
559 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
560 [ "$mails" == "-" ] && mails=""
568 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
570 if [ -z "${line}" ] ; then echo "" ; return ; fi
577 if [ "$PRINT_MAINTS" != 'y' ] ; then
584 local loc=`get_target_location $1`
586 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
588 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
590 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
592 local dir=`echo ${loc} | cut -d ":" -f 2`
593 local cfg=`echo ${loc} | cut -d ":" -f 1`
594 local git_result=`git log --format=%aE board/${dir} \
595 include/configs/${cfg}.h | grep "@"`
596 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
598 local git_result_top=`echo ${git_result} | tr " " "\n" | \
599 sort | uniq -c | sort -nr | head -n 3 | \
600 sed "s/^ \+[0-9]\+ \+//"`
602 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
603 sort -u | tr "\n" " " | sed "s/ $//" ;
605 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
612 # Each finished build will have a file called ${donep}${n},
613 # where n is the index of the build. Each build
614 # we've already noted as finished will have ${skipp}${n}.
615 # The code managing the build process will use this information
616 # to ensure that only BUILD_NBUILDS builds are in flight at once
617 donep="${LOG_DIR}/._done_"
618 skipp="${LOG_DIR}/._skip_"
620 build_target_killed() {
621 echo "Aborted $target build."
622 # Remove the logs for this board since it was aborted
623 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
631 if [ "$ONLY_LIST" == 'y' ] ; then
632 list_target ${target}
636 if [ $BUILD_MANY == 1 ] ; then
637 output_dir="${OUTPUT_PREFIX}/${target}"
638 mkdir -p "${output_dir}"
639 trap build_target_killed TERM
641 output_dir="${OUTPUT_PREFIX}"
644 target_arch=$(get_target_arch ${target})
645 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
646 if [ "${cross_toolchain}" ] ; then
647 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
648 elif [ "${CROSS_COMPILE}" ] ; then
649 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
654 if [ "${output_dir}" != "." ] ; then
655 MAKE="${MAKE} O=${output_dir}"
658 ${MAKE} mrproper >/dev/null
660 echo "Building ${target} board..."
661 ${MAKE} -s ${target}_defconfig >/dev/null
663 ${MAKE} ${JOBS} ${CHECK} all \
664 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
666 # Check for 'make' errors
667 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
671 if [ $BUILD_MANY == 1 ] ; then
676 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
677 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
679 rm ${LOG_DIR}/${target}.ERR
682 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
683 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
684 : $(( ERR_CNT += 1 ))
685 ERR_LIST="${ERR_LIST} $target"
687 : $(( WRN_CNT += 1 ))
688 WRN_LIST="${WRN_LIST} $target"
691 rm ${LOG_DIR}/${target}.ERR
695 OBJS=${output_dir}/u-boot
696 if [ -e ${output_dir}/spl/u-boot-spl ]; then
697 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
700 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
702 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
704 touch "${donep}${build_idx}"
708 search_idx=${OLDEST_IDX}
709 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
712 if [ -e "${donep}${search_idx}" ] ; then
713 : $(( CURRENT_CNT-- ))
714 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
715 : $(( OLDEST_IDX++ ))
717 # Only want to count it once
718 rm -f "${donep}${search_idx}"
719 touch "${skipp}${search_idx}"
720 elif [ -e "${skipp}${search_idx}" ] ; then
721 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
722 : $(( OLDEST_IDX++ ))
724 : $(( search_idx++ ))
725 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
726 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
727 search_idx=${OLDEST_IDX}
738 # If a LIST_xxx var exists, use it. But avoid variable
739 # expansion in the eval when a board name contains certain
740 # characters that the shell interprets.
743 *) list=$(eval echo '${LIST_'$t'}') ;;
745 if [ -n "${list}" ] ; then
746 build_targets ${list}
748 : $((TOTAL_CNT += 1))
749 : $((CURRENT_CNT += 1))
750 rm -f "${donep}${TOTAL_CNT}"
751 rm -f "${skipp}${TOTAL_CNT}"
752 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
754 touch "${donep}${TOTAL_CNT}"
755 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
757 touch "${donep}${TOTAL_CNT}"
759 if [ $BUILD_MANY == 1 ] ; then
760 build_target ${t} ${TOTAL_CNT} &
763 build_target ${t} ${TOTAL_CNT}
769 # We maintain a running count of all the builds we have done.
770 # Each finished build will have a file called ${donep}${n},
771 # where n is the index of the build. Each build
772 # we've already noted as finished will have ${skipp}${n}.
773 # We track the current index via TOTAL_CNT, and the oldest
774 # index. When we exceed the maximum number of parallel builds,
775 # We look from oldest to current for builds that have completed,
776 # and update the current count and oldest index as appropriate.
777 # If we've gone through the entire list, wait a second, and
778 # reprocess the entire list until we find a build that has
780 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
786 #-----------------------------------------------------------------------
793 # Mac OS X is known to have BSD style ps
794 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
795 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
798 # everything else tries the GNU style
799 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
800 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
804 kill $children 2> /dev/null
805 wait $children 2> /dev/null
811 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
813 # Only count boards that completed
814 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
816 rm -f ${donep}* ${skipp}*
818 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
819 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
820 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
821 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
822 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
823 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
824 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
826 # Remove the logs for any board that was interrupted
827 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
830 : $((TOTAL_CNT -= ${SKIP_CNT}))
832 echo "--------------------- SUMMARY ----------------------------"
833 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
834 echo "Boards skipped: ${SKIP_CNT}"
836 echo "Boards compiled: ${TOTAL_CNT}"
837 if [ ${ERR_CNT} -gt 0 ] ; then
838 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
840 if [ ${WRN_CNT} -gt 0 ] ; then
841 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
843 echo "----------------------------------------------------------"
845 if [ $BUILD_MANY == 1 ] ; then
852 #-----------------------------------------------------------------------
854 # Build target groups selected by options, plus any command line args
855 set -- ${SELECTED} "$@"
856 # run PowerPC by default
857 [ $# = 0 ] && set -- powerpc